/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:17:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.analytics.model;

/**
 * JSON template for an Analytics custom data source.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Analytics API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CustomDataSource extends com.google.api.client.json.GenericJson {

  /**
   * Account ID to which this custom data source belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String accountId;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ChildLink childLink;

  /**
   * Time this custom data source was created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime created;

  /**
   * Description of custom data source.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Custom data source ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Resource type for Analytics custom data source.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Name of this custom data source.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Parent link for this custom data source. Points to the web property to which this custom data
   * source belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ParentLink parentLink;

  /**
   * IDs of views (profiles) linked to the custom data source.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> profilesLinked;

  /**
   * Link for this Analytics custom data source.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * Type of the custom data source.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Time this custom data source was last modified.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime updated;

  /**
   * Web property ID of the form UA-XXXXX-YY to which this custom data source belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String webPropertyId;

  /**
   * Account ID to which this custom data source belongs.
   * @return value or {@code null} for none
   */
  public java.lang.String getAccountId() {
    return accountId;
  }

  /**
   * Account ID to which this custom data source belongs.
   * @param accountId accountId or {@code null} for none
   */
  public CustomDataSource setAccountId(java.lang.String accountId) {
    this.accountId = accountId;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public ChildLink getChildLink() {
    return childLink;
  }

  /**
   * @param childLink childLink or {@code null} for none
   */
  public CustomDataSource setChildLink(ChildLink childLink) {
    this.childLink = childLink;
    return this;
  }

  /**
   * Time this custom data source was created.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreated() {
    return created;
  }

  /**
   * Time this custom data source was created.
   * @param created created or {@code null} for none
   */
  public CustomDataSource setCreated(com.google.api.client.util.DateTime created) {
    this.created = created;
    return this;
  }

  /**
   * Description of custom data source.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Description of custom data source.
   * @param description description or {@code null} for none
   */
  public CustomDataSource setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Custom data source ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Custom data source ID.
   * @param id id or {@code null} for none
   */
  public CustomDataSource setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Resource type for Analytics custom data source.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Resource type for Analytics custom data source.
   * @param kind kind or {@code null} for none
   */
  public CustomDataSource setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Name of this custom data source.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name of this custom data source.
   * @param name name or {@code null} for none
   */
  public CustomDataSource setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Parent link for this custom data source. Points to the web property to which this custom data
   * source belongs.
   * @return value or {@code null} for none
   */
  public ParentLink getParentLink() {
    return parentLink;
  }

  /**
   * Parent link for this custom data source. Points to the web property to which this custom data
   * source belongs.
   * @param parentLink parentLink or {@code null} for none
   */
  public CustomDataSource setParentLink(ParentLink parentLink) {
    this.parentLink = parentLink;
    return this;
  }

  /**
   * IDs of views (profiles) linked to the custom data source.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getProfilesLinked() {
    return profilesLinked;
  }

  /**
   * IDs of views (profiles) linked to the custom data source.
   * @param profilesLinked profilesLinked or {@code null} for none
   */
  public CustomDataSource setProfilesLinked(java.util.List<java.lang.String> profilesLinked) {
    this.profilesLinked = profilesLinked;
    return this;
  }

  /**
   * Link for this Analytics custom data source.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * Link for this Analytics custom data source.
   * @param selfLink selfLink or {@code null} for none
   */
  public CustomDataSource setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Type of the custom data source.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * Type of the custom data source.
   * @param type type or {@code null} for none
   */
  public CustomDataSource setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  /**
   * Time this custom data source was last modified.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getUpdated() {
    return updated;
  }

  /**
   * Time this custom data source was last modified.
   * @param updated updated or {@code null} for none
   */
  public CustomDataSource setUpdated(com.google.api.client.util.DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * Web property ID of the form UA-XXXXX-YY to which this custom data source belongs.
   * @return value or {@code null} for none
   */
  public java.lang.String getWebPropertyId() {
    return webPropertyId;
  }

  /**
   * Web property ID of the form UA-XXXXX-YY to which this custom data source belongs.
   * @param webPropertyId webPropertyId or {@code null} for none
   */
  public CustomDataSource setWebPropertyId(java.lang.String webPropertyId) {
    this.webPropertyId = webPropertyId;
    return this;
  }

  @Override
  public CustomDataSource set(String fieldName, Object value) {
    return (CustomDataSource) super.set(fieldName, value);
  }

  @Override
  public CustomDataSource clone() {
    return (CustomDataSource) super.clone();
  }

  /**
   * Model definition for CustomDataSourceChildLink.
   */
  public static final class ChildLink extends com.google.api.client.json.GenericJson {

    /**
     * Link to the list of daily uploads for this custom data source. Link to the list of uploads for
     * this custom data source.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String href;

    /**
     * Value is "analytics#dailyUploads". Value is "analytics#uploads".
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * Link to the list of daily uploads for this custom data source. Link to the list of uploads for
     * this custom data source.
     * @return value or {@code null} for none
     */
    public java.lang.String getHref() {
      return href;
    }

    /**
     * Link to the list of daily uploads for this custom data source. Link to the list of uploads for
     * this custom data source.
     * @param href href or {@code null} for none
     */
    public ChildLink setHref(java.lang.String href) {
      this.href = href;
      return this;
    }

    /**
     * Value is "analytics#dailyUploads". Value is "analytics#uploads".
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * Value is "analytics#dailyUploads". Value is "analytics#uploads".
     * @param type type or {@code null} for none
     */
    public ChildLink setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    @Override
    public ChildLink set(String fieldName, Object value) {
      return (ChildLink) super.set(fieldName, value);
    }

    @Override
    public ChildLink clone() {
      return (ChildLink) super.clone();
    }

  }

  /**
   * Parent link for this custom data source. Points to the web property to which this custom data
   * source belongs.
   */
  public static final class ParentLink extends com.google.api.client.json.GenericJson {

    /**
     * Link to the web property to which this custom data source belongs.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String href;

    /**
     * Value is "analytics#webproperty".
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * Link to the web property to which this custom data source belongs.
     * @return value or {@code null} for none
     */
    public java.lang.String getHref() {
      return href;
    }

    /**
     * Link to the web property to which this custom data source belongs.
     * @param href href or {@code null} for none
     */
    public ParentLink setHref(java.lang.String href) {
      this.href = href;
      return this;
    }

    /**
     * Value is "analytics#webproperty".
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * Value is "analytics#webproperty".
     * @param type type or {@code null} for none
     */
    public ParentLink setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    @Override
    public ParentLink set(String fieldName, Object value) {
      return (ParentLink) super.set(fieldName, value);
    }

    @Override
    public ParentLink clone() {
      return (ParentLink) super.clone();
    }

  }

}
